<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPassengerFlyerCard ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfPassengerFlyerCard extends AbstractStructArrayBase
{
    /**
     * The PassengerFlyerCard
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \dgsoft\StructType\DgPassengerFlyerCard[]
     */
    public $PassengerFlyerCard;
    /**
     * Constructor method for ArrayOfPassengerFlyerCard
     * @uses DgArrayOfPassengerFlyerCard::setPassengerFlyerCard()
     * @param \dgsoft\StructType\DgPassengerFlyerCard[] $passengerFlyerCard
     */
    public function __construct(array $passengerFlyerCard = array())
    {
        $this
            ->setPassengerFlyerCard($passengerFlyerCard);
    }
    /**
     * Get PassengerFlyerCard value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \dgsoft\StructType\DgPassengerFlyerCard[]|null
     */
    public function getPassengerFlyerCard()
    {
        return isset($this->PassengerFlyerCard) ? $this->PassengerFlyerCard : null;
    }
    /**
     * Set PassengerFlyerCard value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgPassengerFlyerCard[] $passengerFlyerCard
     * @return \dgsoft\ArrayType\DgArrayOfPassengerFlyerCard
     */
    public function setPassengerFlyerCard(array $passengerFlyerCard = array())
    {
        foreach ($passengerFlyerCard as $arrayOfPassengerFlyerCardPassengerFlyerCardItem) {
            // validation for constraint: itemType
            if (!$arrayOfPassengerFlyerCardPassengerFlyerCardItem instanceof \dgsoft\StructType\DgPassengerFlyerCard) {
                throw new \InvalidArgumentException(sprintf('The PassengerFlyerCard property can only contain items of \dgsoft\StructType\DgPassengerFlyerCard, "%s" given', is_object($arrayOfPassengerFlyerCardPassengerFlyerCardItem) ? get_class($arrayOfPassengerFlyerCardPassengerFlyerCardItem) : gettype($arrayOfPassengerFlyerCardPassengerFlyerCardItem)), __LINE__);
            }
        }
        if (is_null($passengerFlyerCard) || (is_array($passengerFlyerCard) && empty($passengerFlyerCard))) {
            unset($this->PassengerFlyerCard);
        } else {
            $this->PassengerFlyerCard = $passengerFlyerCard;
        }
        return $this;
    }
    /**
     * Add item to PassengerFlyerCard value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgPassengerFlyerCard $item
     * @return \dgsoft\ArrayType\DgArrayOfPassengerFlyerCard
     */
    public function addToPassengerFlyerCard(\dgsoft\StructType\DgPassengerFlyerCard $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgPassengerFlyerCard) {
            throw new \InvalidArgumentException(sprintf('The PassengerFlyerCard property can only contain items of \dgsoft\StructType\DgPassengerFlyerCard, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PassengerFlyerCard[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgPassengerFlyerCard|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgPassengerFlyerCard|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgPassengerFlyerCard|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgPassengerFlyerCard|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgPassengerFlyerCard|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PassengerFlyerCard
     */
    public function getAttributeName()
    {
        return 'PassengerFlyerCard';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfPassengerFlyerCard
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
